﻿namespace UltraGridExportToExcelNumbers
{
    using System;
    using System.Data;
    using System.Diagnostics;
    using System.Globalization;
    using System.Windows.Forms;

    using Infragistics.Documents.Excel;

    public partial class Form1 : Form
    {
        private const int RowsCount = 10;
        private const string OutputFileName = @"test.xlsx";

        private Random random = new Random();
        private string groupSeparator = CultureInfo.CurrentCulture.NumberFormat.NumberGroupSeparator;
        private string decimalSeparator = CultureInfo.CurrentCulture.NumberFormat.NumberDecimalSeparator;
        private string customFormatString = "#{0}###{1}00";

        public Form1()
        {
            this.InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = this.GetDataSource(RowsCount);
        }

        private void ButtonExport_Click(object sender, EventArgs e)
        {
            this.ultraGridExcelExporter1.Export(this.ultraGrid1, OutputFileName);
            Process.Start(OutputFileName);
        }

        private void UltraGridExcelExporter1_InitializeColumn(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.InitializeColumnEventArgs e)
        {
            if (e.Column.Key == "Count")
            {
                e.ExcelFormatStr = string.Format(this.customFormatString, this.groupSeparator, this.decimalSeparator);
            }
        }

        private DataSet GetDataSource(int rows)
        {
            DataSet ds = new DataSet();
            DataTable dt = ds.Tables.Add();

            dt.Columns.Add("Id", typeof(int));
            dt.Columns.Add("Count", typeof(double));

            for (int row = 0; row < rows; row++)
            {
                double count = this.random.Next(0, 10000000) / 100.0;
                dt.Rows.Add(new object[] { row, count });
            }

            return ds;
        }
    }
}
